// Region top sort 4 programs [Basic, Less Conflict, Full exchange, 2Top]

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

// Active sort algorithm
//#define		sort_core()	gcc_sort()
//#define		sort_core()	region_top_sort()
//#define		sort_core()	region_top_sort_less_conflict()
#define		sort_core()	region_top_sort_full_region()
//#define		sort_core()	twotop_sort()
//#define		sort_core()	region_top_bottom_sort()

// Switch
#define		ACENDING		// Sort order is Acending
//#define		OUTPUT_ALL		// Output all data
//#define		STABLE				// Make stable when data is equal

// Sort data itself
#define		AMOUNT_MAX	1000				// Sort Data Maximum Amount
#define		compare(a, b) 	(int)((a) - (b))	// Comparison method
typedef		int		data_type;				// Sorted data type

data_type	item[AMOUNT_MAX];			// Sort Data
unsigned int	amount;					// Actual Sort Data Amount
_Bool		sw;						 //  Switch Acending[昇順] or Decending[降順]

// Measurement
unsigned long long	count;				// Sorting count [ソートを行った回数]
unsigned long long	compare_count;		// Comparison count [比較回数]
unsigned long long	exchange_count;			// Exchange count [交換回数]
//unsigned int	compare_count_array[AMOUNT_MAX];		// Array for comparison count distribution [比較回数分布確認配列]
//unsigned int	exchange_count_array[AMOUNT_MAX];			// Array for exchange count distribution [交換回数分布確認配列]

// Option
unsigned int	original_order[AMOUNT_MAX];		// Index for same order data comparion(if necessary) [同位のデータの場合、元の順番が前のものを前にする必要がある場合]

// - Common process of every sort [あらゆるソートで共通の処理]

// Judge location1 data wins location2 data or not [2 つのどちらが勝ちが Judge]
_Bool	win(unsigned int location1, unsigned int location2) {

	int		i = compare(item[location1], item[location2]);

	compare_count++;

#ifdef STABLE
		return	((!sw && i < 0) || (sw && i > 0) || (i == 0 && original_order[location1] < original_order[location2]));
#else
		return	((!sw && i < 0) || (sw && i > 0));
#endif
}

// Excenge 2 data [2 つの交換]
void	exchange(unsigned int location1, unsigned int location2) {

	data_type		dtemp;
	unsigned int	itemp;

	exchange_count++;

	dtemp = item[location1];
	item[location1] = item[location2];
	item[location2] = dtemp;

#ifdef STABLE
	itemp = original_order[location1];
	original_order[location1] = original_order[location2];
	original_order[location2] = itemp;
#endif
}

// - Process Region top sort [リージョントップ・ソート用処理]

// Return size([Data amount) of the largest section which 'section_top' is the top. [それが地区のトップ(最小番号)となるような地区の大きさ(データ数)]
// If odd number, return 1. (Top of itself only) [奇数ならばデータ数は 1 (自分だけならトップ)]
unsigned int	section_size_from_top(unsigned int section_top) {

	unsigned int	section_size = 1;

	if (section_top == 0) {					// 0th location is top of 2^N (>= amount)
		while (section_size < amount)
			section_size *= 2;
	}
	else {
		while ((section_top & 1) == 0) {	// Other locations are top of section binary number 0 series size.
			section_top /= 2;
			section_size *= 2;
		}
	}
	return	section_size;
}

// Declaration for recurrsive [再帰の為の宣言]
void	down_to_the_section(unsigned int section_top_location);

// Match between two section top [地区のトップ同士の試合]
// 'superior' should higher rank location(front side) of these. ['superior' が上位位置(前側)である事]
// Exchange location if inferior wins superior. [下位位置が上位位置に勝てば、入れ替える]
void	top_match_for_location(unsigned int superior, unsigned int inferior) {

	if (inferior < amount && win(inferior, superior)) {
		exchange(inferior, superior);
		down_to_the_section(inferior);
	}
}

// Arrangement of the data down to the section [この地区に上から降格してきたデータの位置調整]
// In this section, repeat top match between the data and sections top included. [その地区内で、そのデータと含まれる各地区トップとの試合をしていく]
void	down_to_the_section(unsigned int section_top_location) {

	unsigned int	distance;
	unsigned int	section_size = section_size_from_top(section_top_location);

//	if (section_size == 1)
//		return;

	for (distance = 1; distance < section_size; distance *= 2)
		top_match_for_location(section_top_location, section_top_location + distance);
}

// Region top sort main process [リージョントップ・ソート本体]
void	region_top_sort() {

	unsigned int	size, distance, non_sorted, i;

// Choose top of the section (size of 2, 4, 8, 16 .. 2^n) and set it to the place smallest number. [2, 4, 8, 16 .. 2^n 個毎の各地区で、最小番号となる位置にその地区のトップが入るようにする.]
// 0th is champion after this process. [終わった時、0 番目がチャンピオン]
	for (size = 2, distance = 1; distance < amount; size *= 2, distance *= 2) {
		for (i = 0; i < amount; i += size) {
			top_match_for_location(i, i + distance);
		}
	}

// From 1th to end, do match with top of the next sections. [1番目以降は、それ以降にある各地区のトップとの試合をしていく]
	for (non_sorted = 1; non_sorted < amount; non_sorted++) {
		for (i = non_sorted; i < amount; ) {
			i += section_size_from_top(i);
			top_match_for_location(non_sorted, i);
		}
	}
}

// - Process Region top sort (Less Confliction Altenation) [リージョントップ・ソート(摩擦減少変更)用処理]

// Do almost same as 'down_to_the_section' above. [上記 'down_to_the_section' とほとんど同じ]
// Limit exchange time only one. moving the suitable data to the section top location. [交換を適したデータを地域の一番前に持ってくる1回だけにする。]
void	down_to_the_section_1exchange_only(unsigned int section_top_location) {

	unsigned int		distance;
	unsigned int		really_top, i;
	unsigned int		section_size = section_size_from_top(section_top_location);

//	if (section_size == 1)
//		return;

	really_top = section_top_location;
	for (distance = 1; distance < section_size; distance *= 2) {
		i = section_top_location + distance;
		if (i < amount && win(i, really_top))
			really_top = i;
	}

	if (section_top_location != really_top) {
		exchange(really_top, section_top_location);
		down_to_the_section_1exchange_only(really_top);
	}
}

// Region top sort (less conflict) main process [リージョントップ・ソート摩擦減少版本体]
void	region_top_sort_less_conflict() {

	unsigned int	size, distance, i, j, non_sorted, suitable_data;

// Do the same 'region_top_sort' except calling 'down_to_the_section_1exchange_only' ['down_to_the_section_1exchange_only' を呼ぶ以外は同じ]
	for (size = 2, distance = 1; distance < amount; size *= 2, distance *= 2) {
		for (i = 0; i < amount; i += size) {
			j = i + distance;
			if (j < amount && win(j, i)) {
				exchange(j, i);
				down_to_the_section_1exchange_only(j);
			}
		}
	}

// Don't exchange at match. Get suitable_data. Exchange only the case it is different from non_sorted. [試合毎に入れ替えをせず suitable_data を求め non_sorted と違った場合のみ入れ替え]
	for (non_sorted = 1; non_sorted < amount; non_sorted++) {
		suitable_data = non_sorted;
		for (i = non_sorted; i < amount; ) {
			i += section_size_from_top(i);
			if (i < amount && win(i, suitable_data))
				suitable_data = i;
		}
		if (non_sorted != suitable_data) {
			exchange(suitable_data, non_sorted);
			down_to_the_section_1exchange_only(suitable_data);
		}
	}
}

// - Process Region top sort (Full region exchange Altenation) [リージョントップ・ソート(全地域交換変更)用処理]

// Region top sort([Full region exchange Alternation) main process [リージョントップ・ソート(全地域交換変更)本体]
void	region_top_sort_full_region() {

	unsigned int	size, distance, i, j, k, non_sorted, suitable_data;

// Fill data until 2^N [2^N までデータを詰める]
	for (i = 1; i < amount; i *= 2);
	for ( ; amount < i; amount++)
		item[amount] = (!sw ? INT_MAX : INT_MIN);

// Exchange full region [交換時、全地域交換とする]
	for (size = 2, distance = 1; distance < amount; size *= 2, distance *= 2) {
		for (i = 0; i < amount; i += size) {
			j = i + distance;
			if (j < amount && win(j, i)) {
				for (k = 0; k < distance; k++)
					exchange(j + k, i + k);
			}
		}
	}

// Same as 'region_top_sort_less_conflict()'
	for (non_sorted = 1; non_sorted < amount; non_sorted++) {
		suitable_data = non_sorted;
		for (i = non_sorted; i < amount; ) {
			i += section_size_from_top(i);
			if (i < amount && win(i, suitable_data))
				suitable_data = i;
		}
		if (non_sorted != suitable_data) {
			exchange(suitable_data, non_sorted);
			down_to_the_section_1exchange_only(suitable_data);
		}
	}
}

// - Process Two Top Sort [ツートップソート用処理]

// Arrangement for the data down to the section [この地区に上から降格してきたデータの位置調整]
// In this section, repeat top match and runner-up match. [その地区内で、トップの試合と次点者の試合をしていく]
void	down_to_the_section_2top(unsigned int section_top_location) {

	unsigned int		section_size = section_size_from_top(section_top_location);
	unsigned int		section_second, k;

	if (section_size == 1)
		return;

	section_second = section_top_location + section_size / 2;
	if (section_second < amount && win(section_second, section_top_location)) {
		exchange(section_second, section_top_location);
		down_to_the_section_2top(section_second);
		k = section_size / 4;
		while (k > 0 && win(section_second - k, section_second)) {
			exchange(section_second, section_second - k);
			down_to_the_section_2top(section_second - k);
			section_second = section_second - k;
			k /= 2;
		}
	}
}

// Two Top Sort main process [ツートップソート本体]
void	twotop_sort() {

	unsigned int	size, distance, non_sorted, suitable_data, i, j, k;

// Set top to the place smallest number in the section. And set runner-up to the location half of the section. [その地区のトップを最小番号の位置に、次点者を半分の位置に入れる]
	for (size = 2, distance = 1; distance < amount; size *= 2, distance *= 2) {
		for (i = 0; i < amount; i += size) {
			j = i + distance;
			if (j < amount) {
				if (win(j, i)) {
					exchange(j, i);
					down_to_the_section_2top(j);
				}
				else {
					k = distance / 2;
					while (k > 0 && win(j - k, j)) {
						exchange(j, j - k);
						down_to_the_section_2top(j - k);
						j = j - k;
						k /= 2;
					}
				}
			}
		}
	}

// When 'non_sorted' is top of the section, set runners-up data to next place. ['non_sorted' が地域トップの時、次点者も次に入れる]
// Otherwise, same as previous. [それ以外は以前と同じ]
	for (non_sorted = 0; non_sorted < amount; non_sorted++) {
		i = section_size_from_top(non_sorted);
		if (non_sorted + i >= amount) {
			i = non_sorted + i / 2;
			non_sorted++;
			if (i < amount) {
				exchange(non_sorted, i);
				down_to_the_section_2top(i);
			}
		}
		else {
			suitable_data = non_sorted;
			for (i = non_sorted; i < amount; ) {
				i += section_size_from_top(i);
				if (i < amount && win(i, suitable_data))
					suitable_data = i;
			}
			if (non_sorted != suitable_data) {
				exchange(suitable_data, non_sorted);
				down_to_the_section_2top(suitable_data);
			}
		}
	}
}

// Return size([Data amount) of the largest section which 'section_bottom' is the bottom. [それが地区のボトム(最大番号)となるような地区の大きさ(データ数)]
// If even number, return 1. (Bottom of itself only) [偶数ならばデータ数は 1 (自分だけならボトム)]
// (Not used)
unsigned int	section_size_from_bottom(unsigned int section_bottom) {

	return	section_size_from_top(section_bottom + 1);
}

// Main for all kind sort

// Read data from standard input. Separetor of each data is space. [標準入力からのデータ読み込み。スペースがデータ間切れ目]
// Other letters (Normally return) are separator between series of sort data. [他の文字は一続きのデータの切れ目(通常リターン)]
_Bool	get_sort_data() {

	amount = 0;
	do {
		if (scanf("%d", &item[amount]) == EOF)
			return	0;
		amount++;
	} while (getchar() == ' ');

	return	1;
}

// For making all combination data from amount, make one data of the count. [全組み合わせのデータを作る為のcount番目データ]
_Bool	make_sort_data() {

	unsigned int	i;
	unsigned long long	j, k;

	k = 1;
	for (i = 2; i <= amount; i++) {
		k *= i;
	}
	if (count >= k)			// End
		return	0;

	j = count;
	for (i = 0; i < amount; i++) {
		k /= (amount - i);
		if (k == 0)	{
			printf("Exceed this program (unsigned long long) range\n");
			return	0;
		}
		item[i] = j / k;
		j %= k;
	}

	for (i = 0; i < amount; i++)		// Use original_order[] array for memory of already used or not
		original_order[i] = i;

	for (i = 0; i < amount; i++) {
		j = -1;
		do {
			for (j++; original_order[j] == -1; j++);
			item[i]--;
		} while (item[i] >= 0);

		item[i] = original_order[j];
		original_order[j] = -1;
	}
	return	1;
}

// gcc libraly sort - for time comparison

int	int_sort(const void *a, const void *b) {

	int		i = *(int *)a - *(int *)b;

	compare_count++;
	if ((!sw && i < 0) || (sw && i > 0))
		return	-1;
	else if ((!sw && i > 0) || (sw && i < 0))
		return	1;
	else
		return	0;
}

void	gcc_sort() {

	qsort((void *)item, (size_t)amount, sizeof(item[0]), int_sort);
}

// Main program of sort [メインプログラム]
// If there is argument of number, sort the all combination of the amount data. [引数の個数のデータの全組み合わせデータをソート]
// No argument, sort data form standard input. [引数ない場合、標準入力のデータをソート]
int		main(int argc, char *argv[]) {

	unsigned int		i;
	unsigned long long	compare_min, exchange_min, compare_max, exchange_max;
	double		compare_total, exchange_total;
	_Bool	ok;
	_Bool	input;

	if (argc == 2) {
		amount = atoi(argv[1]);
		if (amount <= 0 || amount > AMOUNT_MAX) {
			printf("Sort data amount error\n");
			return	1;
		}
		input = 0;
	}
	else if (argc != 1) {
		printf("Command argument error\n");
		return	1;
	}
	else {
		amount = 0;
		input = 1;
	}

//	for (i = 0; i < AMOUNT_MAX; i++)
//		compare_count_array[i] = 0;
//	for (i = 0; i < AMOUNT_MAX; i++)
//		exchange_count_array[i] = 0;
	compare_total = 0;
	exchange_total = 0;
	compare_min = 0xffff;
	exchange_min = 0xffff;
	compare_max = 0;
	exchange_max = 0;

#ifdef ACENDING
	sw = 0;
#else
	sw = 1;
#endif

	count = 0;
	while (1) {

// Sort Data Read [Data 読み込み]
		if (input) {
			if (!get_sort_data())
				goto	L1;
		}
		else {
			if (!make_sort_data())
				goto	L1;
		}

#ifdef STABLE
		for (i = 0; i < amount; i++)
			original_order[i] = i;
#endif

		compare_count = 0;
		exchange_count = 0;
#ifdef OUTPUT_ALL
		for (i = 0; i < amount; i++)
			printf("%d ", item[i]);
#endif

		sort_core();
		count++;
		compare_total += (double)compare_count;
		exchange_total += (double)exchange_count;
		if (compare_total < (double)compare_count || exchange_total < (double)exchange_count)		// Check count is under range
			printf("Exceed unsigned int range\n");

		if (compare_min > compare_count)
			compare_min = compare_count;
		if (exchange_min > exchange_count)
			exchange_min = exchange_count;

		if (compare_max < compare_count)
			compare_max = compare_count;
		if (exchange_max < exchange_count)
			exchange_max = exchange_count;

// Data output [Data 出力]
		ok = 1;
		for (i = 0; i < amount - 1; i++) {
			if (item[i] > item[i + 1])
				ok = 0;
		}
#ifdef OUTPUT_ALL
		printf(" compare:%lld exchange:%lld - %s\n", compare_count, exchange_count, (ok ? "OK" : "NG"));
#else
		if (!ok)
			printf(" compare:%lld exchange:%lld - %s\n", compare_count, exchange_count, (ok ? "OK" : "NG"));
#endif

//		compare_count_array[compare_count]++;
//		exchange_count_array[exchange_count]++;
	}
L1:
	if (count == 0) {
		printf("Can't make data error\n");
		return	1;
	}
	printf("Data amount:%d Total count:%lld\n", amount, count);
	printf("Compare [minimum:%lld maximum:%lld average:%f]\n", compare_min, compare_max, (compare_total/(double)count));
	printf("Exchange [minimum:%lld maximum:%lld average:%f]\n", exchange_min, exchange_max, (exchange_total/(double)count));

/*	printf(" compare = ");
	for (i = 0, x = 0; i < AMOUNT_MAX; i++) {
		if (compare_count_array[i] > 0) {
			printf("%d:%d ", i, compare_count_array[i]);
			x += i * compare_count_array[i];
		}
	}
	printf("\n");
	printf("av %d\n", (x / count));

	printf(" exchange = ");
	for (i = 0, x = 0; i < AMOUNT_MAX; i++) {
		if (exchange_count_array[i] > 0) {
			printf("%d:%d ", i, exchange_count_array[i]);
			x += i * exchange_count_array[i];
		}
	}
	printf("\n");
	printf("av %d\n", (x / count));*/
	return	0;
}

// End of Region top sort program
